Irrlicht Engine: irr::scene::SSharedMeshBuffer Struct Reference

Home | Namespaces | Hierarchy | Alphabetical List | Class list | Files | Namespace Members | Class members | File members | Tutorials

# irr::scene::SSharedMeshBuffer Struct Reference

Implementation of the IMeshBuffer interface with shared vertex list. More...

`#include <SSharedMeshBuffer.h>`

Inheritance diagram for irr::scene::SSharedMeshBuffer:

List of all members.

## Public Member Functions
virtual void | append (const IMeshBuffer *const other)
| append the meshbuffer to the current buffer
virtual void | append (const void *const vertices, u32 numVertices, const u16 *const indices, u32 numIndices)
| append the vertices and indices to the current buffer
virtual const core::aabbox3d < f32 > & | getBoundingBox () const
| returns an axis aligned bounding box
virtual u32 | getChangedID_Index () const
| Get the currently used ID for identification of changes.
virtual u32 | getChangedID_Vertex () const
| Get the currently used ID for identification of changes.
virtual E_HARDWARE_MAPPING | getHardwareMappingHint_Index () const
| get the current hardware mapping hint
virtual E_HARDWARE_MAPPING | getHardwareMappingHint_Vertex () const
| get the current hardware mapping hint
virtual u32 | getIndexCount () const
| returns amount of indices
virtual u16 * | getIndices ()
| returns pointer to Indices
virtual const u16 * | getIndices () const
| returns pointer to Indices
virtual video::SMaterial & | getMaterial ()
| returns the material of this meshbuffer
virtual const video::SMaterial & | getMaterial () const
| returns the material of this meshbuffer
virtual u32 | getVertexCount () const
| returns amount of vertices
virtual video::E_VERTEX_TYPE | getVertexType () const
| returns which type of vertex data is stored.
virtual void * | getVertices ()
| returns pointer to vertices
virtual const void * | getVertices () const
| returns pointer to vertices
virtual void | recalculateBoundingBox ()
| recalculates the bounding box. should be called if the mesh changed.
virtual void | setBoundingBox (const core::aabbox3df &box)
| set user axis aligned bounding box
virtual void | setDirty (E_BUFFER_TYPE buffer=EBT_VERTEX_AND_INDEX)
| flags the mesh as changed, reloads hardware buffers
virtual void | setHardwareMappingHint (E_HARDWARE_MAPPING NewMappingHint, E_BUFFER_TYPE buffer=EBT_VERTEX_AND_INDEX)
| set the hardware mapping hint, for driver
| SSharedMeshBuffer (core::array< video::S3DVertex > *vertices)
| constructor
| SSharedMeshBuffer ()
| constructor
## Public Attributes
core::aabbox3df | BoundingBox
| Bounding box.
u32 | ChangedID_Index
| ID used for hardware buffer management.
u32 | ChangedID_Vertex
| ID used for hardware buffer management.
core::array< u16 > | Indices
| Array of Indices.
E_HARDWARE_MAPPING | MappingHintIndex
E_HARDWARE_MAPPING | MappingHintVertex
| hardware mapping hint
video::SMaterial | Material
| Material of this meshBuffer.
core::array< video::S3DVertex > * | Vertices
| Shared Array of vertices.

## Detailed Description

Implementation of the IMeshBuffer interface with shared vertex list.

Definition at line 16 of file SSharedMeshBuffer.h.

## Constructor & Destructor Documentation

irr::scene::SSharedMeshBuffer::SSharedMeshBuffer | ( |  | ) | `[inline]`

constructor

Definition at line 19 of file SSharedMeshBuffer.h.

References irr::IReferenceCounted::setDebugName().

irr::scene::SSharedMeshBuffer::SSharedMeshBuffer | ( | core::array< video::S3DVertex > * | vertices | ) | `[inline]`

constructor

Definition at line 27 of file SSharedMeshBuffer.h.

References irr::IReferenceCounted::setDebugName().

## Member Function Documentation

virtual void irr::scene::SSharedMeshBuffer::append | ( | const IMeshBuffer *const | other | ) | `[inline, virtual]`

append the meshbuffer to the current buffer

Implements irr::scene::IMeshBuffer.

Definition at line 126 of file SSharedMeshBuffer.h.

virtual void irr::scene::SSharedMeshBuffer::append | ( | const void *const | vertices,
|  | u32 | numVertices,
|  | const u16 *const | indices,
|  | u32 | numIndices |
| ) |  |  | `[inline, virtual]`

append the vertices and indices to the current buffer

Implements irr::scene::IMeshBuffer.

Definition at line 123 of file SSharedMeshBuffer.h.

virtual const core::aabbox3d<f32>& irr::scene::SSharedMeshBuffer::getBoundingBox | ( |  | ) | const`[inline, virtual]`

returns an axis aligned bounding box

Implements irr::scene::IMeshBuffer.

Definition at line 92 of file SSharedMeshBuffer.h.

References BoundingBox.

virtual u32 irr::scene::SSharedMeshBuffer::getChangedID_Index | ( |  | ) | const`[inline, virtual]`

Get the currently used ID for identification of changes.

This shouldn't be used for anything outside the VideoDriver.

Implements irr::scene::IMeshBuffer.

Definition at line 166 of file SSharedMeshBuffer.h.

References ChangedID_Index.

virtual u32 irr::scene::SSharedMeshBuffer::getChangedID_Vertex | ( |  | ) | const`[inline, virtual]`

Get the currently used ID for identification of changes.

This shouldn't be used for anything outside the VideoDriver.

Implements irr::scene::IMeshBuffer.

Definition at line 162 of file SSharedMeshBuffer.h.

References ChangedID_Vertex.

virtual E_HARDWARE_MAPPING irr::scene::SSharedMeshBuffer::getHardwareMappingHint_Index | ( |  | ) | const`[inline, virtual]`

get the current hardware mapping hint

Implements irr::scene::IMeshBuffer.

Definition at line 136 of file SSharedMeshBuffer.h.

References MappingHintIndex.

virtual E_HARDWARE_MAPPING irr::scene::SSharedMeshBuffer::getHardwareMappingHint_Vertex | ( |  | ) | const`[inline, virtual]`

get the current hardware mapping hint

Implements irr::scene::IMeshBuffer.

Definition at line 130 of file SSharedMeshBuffer.h.

References MappingHintVertex.

virtual u32 irr::scene::SSharedMeshBuffer::getIndexCount | ( |  | ) | const`[inline, virtual]`

returns amount of indices

Implements irr::scene::IMeshBuffer.

Definition at line 86 of file SSharedMeshBuffer.h.

References Indices, and irr::core::array< T, TAlloc >::size().

virtual u16* irr::scene::SSharedMeshBuffer::getIndices | ( |  | ) | `[inline, virtual]`

returns pointer to Indices

Implements irr::scene::IMeshBuffer.

Definition at line 80 of file SSharedMeshBuffer.h.

References Indices, and irr::core::array< T, TAlloc >::pointer().

virtual const u16* irr::scene::SSharedMeshBuffer::getIndices | ( |  | ) | const`[inline, virtual]`

returns pointer to Indices

Implements irr::scene::IMeshBuffer.

Definition at line 74 of file SSharedMeshBuffer.h.

References irr::core::array< T, TAlloc >::const_pointer(), and Indices.

virtual video::SMaterial& irr::scene::SSharedMeshBuffer::getMaterial | ( |  | ) | `[inline, virtual]`

returns the material of this meshbuffer

Implements irr::scene::IMeshBuffer.

Definition at line 41 of file SSharedMeshBuffer.h.

References Material.

virtual const video::SMaterial& irr::scene::SSharedMeshBuffer::getMaterial | ( |  | ) | const`[inline, virtual]`

returns the material of this meshbuffer

Implements irr::scene::IMeshBuffer.

Definition at line 35 of file SSharedMeshBuffer.h.

References Material.

virtual u32 irr::scene::SSharedMeshBuffer::getVertexCount | ( |  | ) | const`[inline, virtual]`

returns amount of vertices

Implements irr::scene::IMeshBuffer.

Definition at line 65 of file SSharedMeshBuffer.h.

References irr::core::array< T, TAlloc >::size(), and Vertices.

virtual video::E_VERTEX_TYPE irr::scene::SSharedMeshBuffer::getVertexType | ( |  | ) | const`[inline, virtual]`

returns which type of vertex data is stored.

Implements irr::scene::IMeshBuffer.

Definition at line 104 of file SSharedMeshBuffer.h.

References irr::video::EVT_STANDARD.

virtual void* irr::scene::SSharedMeshBuffer::getVertices | ( |  | ) | `[inline, virtual]`

returns pointer to vertices

Implements irr::scene::IMeshBuffer.

Definition at line 56 of file SSharedMeshBuffer.h.

References irr::core::array< T, TAlloc >::pointer(), and Vertices.

virtual const void* irr::scene::SSharedMeshBuffer::getVertices | ( |  | ) | const`[inline, virtual]`

returns pointer to vertices

Implements irr::scene::IMeshBuffer.

Definition at line 47 of file SSharedMeshBuffer.h.

References irr::core::array< T, TAlloc >::const_pointer(), and Vertices.

virtual void irr::scene::SSharedMeshBuffer::recalculateBoundingBox | ( |  | ) | `[inline, virtual]`

recalculates the bounding box. should be called if the mesh changed.

Implements irr::scene::IMeshBuffer.

Definition at line 110 of file SSharedMeshBuffer.h.

References irr::core::aabbox3d< T >::addInternalPoint(), BoundingBox, irr::core::array< T, TAlloc >::empty(), Indices, irr::core::aabbox3d< T >::reset(), irr::core::array< T, TAlloc >::size(), and Vertices.

virtual void irr::scene::SSharedMeshBuffer::setBoundingBox | ( | const core::aabbox3df & | box | ) | `[inline, virtual]`

set user axis aligned bounding box

Implements irr::scene::IMeshBuffer.

Definition at line 98 of file SSharedMeshBuffer.h.

References BoundingBox.

virtual void irr::scene::SSharedMeshBuffer::setDirty | ( | E_BUFFER_TYPE | buffer = `EBT_VERTEX_AND_INDEX` | ) | `[inline, virtual]`

flags the mesh as changed, reloads hardware buffers

Implements irr::scene::IMeshBuffer.

Definition at line 152 of file SSharedMeshBuffer.h.

References ChangedID_Index, ChangedID_Vertex, irr::scene::EBT_INDEX, irr::scene::EBT_VERTEX, and irr::scene::EBT_VERTEX_AND_INDEX.

virtual void irr::scene::SSharedMeshBuffer::setHardwareMappingHint | ( | E_HARDWARE_MAPPING | NewMappingHint,
|  | E_BUFFER_TYPE | buffer = `EBT_VERTEX_AND_INDEX` |
| ) |  |  | `[inline, virtual]`

set the hardware mapping hint, for driver

Implements irr::scene::IMeshBuffer.

Definition at line 142 of file SSharedMeshBuffer.h.

References irr::scene::EBT_INDEX, irr::scene::EBT_VERTEX, irr::scene::EBT_VERTEX_AND_INDEX, MappingHintIndex, and MappingHintVertex.

## Member Data Documentation

core::aabbox3df irr::scene::SSharedMeshBuffer::BoundingBox

Bounding box.

Definition at line 184 of file SSharedMeshBuffer.h.

Referenced by getBoundingBox(), recalculateBoundingBox(), and setBoundingBox().

u32 irr::scene::SSharedMeshBuffer::ChangedID_Index

ID used for hardware buffer management.

Definition at line 181 of file SSharedMeshBuffer.h.

Referenced by getChangedID_Index(), and setDirty().

u32 irr::scene::SSharedMeshBuffer::ChangedID_Vertex

ID used for hardware buffer management.

Definition at line 178 of file SSharedMeshBuffer.h.

Referenced by getChangedID_Vertex(), and setDirty().

core::array<u16> irr::scene::SSharedMeshBuffer::Indices

Array of Indices.

Definition at line 175 of file SSharedMeshBuffer.h.

Referenced by getIndexCount(), getIndices(), and recalculateBoundingBox().

E_HARDWARE_MAPPING irr::scene::SSharedMeshBuffer::MappingHintIndex

Definition at line 188 of file SSharedMeshBuffer.h.

Referenced by getHardwareMappingHint_Index(), and setHardwareMappingHint().

E_HARDWARE_MAPPING irr::scene::SSharedMeshBuffer::MappingHintVertex

hardware mapping hint

Definition at line 187 of file SSharedMeshBuffer.h.

Referenced by getHardwareMappingHint_Vertex(), and setHardwareMappingHint().

video::SMaterial irr::scene::SSharedMeshBuffer::Material

Material of this meshBuffer.

Definition at line 169 of file SSharedMeshBuffer.h.

Referenced by getMaterial().

core::array<video::S3DVertex>* irr::scene::SSharedMeshBuffer::Vertices

Shared Array of vertices.

Definition at line 172 of file SSharedMeshBuffer.h.

Referenced by getVertexCount(), getVertices(), and recalculateBoundingBox().

The documentation for this struct was generated from the following file:

- SSharedMeshBuffer.h

| The Irrlicht Engine Documentation © 2003-2010 by Nikolaus Gebhardt. Generated on Sun Oct 24 12:42:09 2010 by Doxygen (1.6.2)